//utf8

/*
 * Copyright 2007 (C) Michal Kalewski
 * mkalewski@cs.put.poznan.pl
 *
 * Use, modification, copying and distribution of this software is subject to
 * the terms and conditions of the MIT License.
 * You should have received a copy of the MIT License along with this
 * software; if not, you can download a copy from http://www.opensource.org.
 *
 * For questions, bug reports, feature requests, support requests etc.
 * send an e-mail to: mkalewski@cs.put.poznan.pl.
 *
 * $Id: smsnet.h,v 1.5 2008-01-10 16:04:33 mkalewski Exp $
 *
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <ctype.h>
#include "smscomm.h"

#define TCPPORTNUMBER 1234
#define QUEUESIZE 5

const char cProtocolWELCOME[] = "SMSCOMM Welcome!\n";
const char cProtocolUSAGE[] = "\nCommands:\n    erase\n    <num>\n    #Erases SMS message number <num>.\n\n    first\n    #Reads first unread SMS message.\n\n    quit\n    #Ends connection.\n\n    read\n    <num>\n    #Reads SMS message number <num>.\n\n    send\n    <gsm num>\n    <text>\n    #Sends SMS message to <gsm num> number.\n\n    shutdown\n    #Stops networking.\n\n";
const char cProtocolERASE[]    = "erase";
const char cProtocolFIRST[]    = "first";
const char cProtocolQUIT[]     = "quit";
const char cProtocolREAD[]     = "read";
const char cProtocolSEND[]     = "send";
const char cProtocolSHUTDOWN[] = "shutdown";

class SMSNetworking
{
        private:
                Logger* _logger;
                GSMModem* _gsmModem;
                int _iSocket;
                int _iClientSocket;
                int _iBind;
                int _iListen;
                int _iTcpPortNumber;
                struct sockaddr_in _stAddr, _stClientAddr;

                bool InitNetworking();

        public:
                SMSNetworking(int, Logger*, GSMModem*);
                static bool IsAlpha(const char*);
                static bool IsNum(const char*);
                bool Networking();
};

//EOF + NL
